      program Lusifer
      implicit none
c local variables
      integer maxe,maxch,maxg,maxv,maxo,maxh
      parameter(maxe=8,maxch=20000,maxg=1,maxv=40,maxo=20,maxh=9)
      real*8 m2,conv,random(3*maxe-10),k(maxe,0:3),factor,energy
      real*8 g(maxch),gsum,average,sigma,av,si,averagemax,weight
      real*8 ccutll,ccutqq,ccutlq,ccutlb,ccutqb,ecutl,ecutq,scutqq
      real*8 x1,x2,wisr,avsub(20),sisub(20)
      real*8 echeck(maxe),scheck(maxe,maxe),ccheck(maxe,maxe)
      real*8 kbeam(2,0:3),weightsub
      integer generator,channel,switch,n,nevents,qalp
      integer lightfermions,includecuts,nocut,scuts,i1,i2,i3,i4,i5
      integer channelmax,nmax,rejected,nparticle,sisr,nsteps,sout
      character*3 name(maxe),gname(0:1,-1:1,3)
      character*100 outputfile,process
      character*6 gfname(0:1,-1:1,3),dgfname(-1:1)
c general
      real*8 alphaisr,scale,meisr,s(2**maxe),p(0:3,2**maxe)
      real*8 mass(0:maxv),width(0:maxv)
      integer nchannel(maxg),nexternal(maxg),allbinary(maxg)
c adaptopt
      real*8 alphaopt(maxch,maxo,maxg),betaopt(0:maxch,maxg)
      real*8 wi(maxch,maxg)
      integer nopt(0:maxo,maxg),opt(maxg)
c lparam
      real*8 pi,el,alpha,alpha0,alphaz,alphas,gf,cw,cw2,sw,sw2
      real*8 mw,mw2,gw,mz,mz2,gz,mh,mh2,gh,me,me2,mt,mt2,gt
c processpar
      complex*16 cvf(20,-1:1,-3:3,8),cvif(20,-1:1,-3:3,8)
      complex*16 cvfvf(20,-1:1,-3:3,8,-1:1,-3:3,8),csbt
      complex*16 cwwvv(-3:3,-3:3,-3:3,-3:3),cvvv(-3:3,-3:3,-3:3)
      complex*16 cvvs(-3:3,-3:3,-3:3),mf(0:4)
      real*8 gs2,mp(-4:4),mp2(-4:4),gp(-4:4),q(20,8),pp,pm
      real*8 polw(20,0:255),sym(20),wgt(20)
      integer fv(20,8,-3:3),qprop,quark(20,8),iso(20,8),gen(20,8),dir(8)
      integer pol(8),nfs
      character*6 fname(20,8),dfname(20,8)
c cuts
      real*8 ecut(maxe),scut(maxe,maxe),ccut(maxe,maxe)
c chisto
      integer shisto,nhisto(maxh)
c qcdoption
      integer qg
c mat2
      real*8 m2fs(20)
c output
      integer nout,numout,maxout
      common/general/alphaisr,scale,meisr,s,p,mass,width,nchannel,
     *  nexternal,allbinary
      common/adaptopt/alphaopt,betaopt,wi,nopt,opt
      common/lparam/pi,el,alpha,alpha0,alphaz,alphas,gf,cw,cw2,sw,sw2,
     *  mw,mw2,gw,mz,mz2,gz,mh,mh2,gh,me,me2,mt,mt2,gt
      common/processpar/cvf,cvif,cvfvf,csbt,cwwvv,cvvv,cvvs,gs2,mp,mp2,
     *  gp,mf,q,pp,pm,polw,sym,wgt,fv,qprop,quark,iso,gen,dir,pol,nfs,
     *  fname,dfname
      common/cuts/ecut,scut,ccut
      common/chisto/shisto,nhisto
      common/qcdoption/qg
      common/mat2/m2fs
      common/output/nout,numout,maxout
      do i1=1,maxe
      do i2=1,maxe
        ecut(i1)=0d0
        scut(i1,i2)=0d0
        ccut(i1,i2)=0d0
      enddo
      enddo
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     read input file                                             c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      read'(a)',outputfile      ! name of output file
      read*,energy              ! CMF energy
      read*,nevents             ! number of events
      read*,qalp                ! choice of input parameter scheme
      read*,qprop               ! choice of propagator
      read*,qg                  ! include qcd 
      read*,sisr                ! include initial-state radiation
      read*,nfs                 ! number of processes
      do i1=1,nfs
        do i2=3,8
          read'(a)',fname(i1,i2)! particle names
        enddo
        read*,wgt(i1)           ! muliplicative process factor  
      enddo
      read*,pp                  ! degree of positron beam polarization
      read*,pm                  ! degree of electron beam polarization
c cuts
      read*,scuts               ! separation cuts
      if(scuts.eq.10)then
c simplified input
        read*,ecutl             ! charged-lepton energy cut
        read*,ecutq             ! quark energy cut
        read*,scutqq            ! quark-quark invariant mass cut
        read*,ccutll            ! angular cut between charged leptons
        read*,ccutqq            ! angular cut between quarks
        read*,ccutlq            ! angular cut between charged lepton and quark
        read*,ccutlb            ! angular cut between charged lepton and beam
        read*,ccutqb            ! angular cut between quark and beam
      elseif(scuts.eq.11)then
c most general input
        do i1=3,8
          read*,ecut(i1)       ! energy cuts
        enddo
        do i1=1,8
        do i2=max(3,i1+1),8
          read*,ccut(i1,i2)    ! angular cuts
        enddo
        enddo
        do i1=3,8
        do i2=i1+1,nparticle+2
          read*,scut(i1,i2)    ! invariant-mass cuts
        enddo
        enddo
      endif
c histograms
      read*,shisto
      if(shisto.eq.1)then
        do i1=1,maxh
          read*,nhisto(i1)     ! include histograms
        enddo
      endif
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     setting particle parameters                                 c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      generator=1                      ! number of generator
      do i1=3,8
        if(fname(1,i1).ne.'      ')nexternal(generator)=i1
      enddo
      nparticle=nexternal(generator)-2                    
c fermion names
      gfname(0,-1,1)='e'
      gfname(0,-1,2)='mu'
      gfname(0,-1,3)='tau' 
      gfname(0,+1,1)='nu_e' 
      gfname(0,+1,2)='nu_mu'
      gfname(0,+1,3)='nu_tau'
      gfname(1,-1,1)='d'
      gfname(1,-1,2)='s'
      gfname(1,-1,3)='b'
      gfname(1,+1,1)='u'
      gfname(1,+1,2)='c'
      gfname(1,+1,3)='t'
      dgfname(+1)='      '
      dgfname(-1)=' anti-'
c particle parameters are fixed
      dir(1)=1 
      dir(2)=1
      do i1=3,nparticle+2
         dir(i1)=-1
         pol(i1)=0
      enddo
      do i1=1,nfs
        fname(i1,1)=gfname(0,-1,1)
        fname(i1,2)=gfname(0,-1,1)
        do i2=1,nparticle+2
          dfname(i1,i2)=dgfname(dir(i2)*(-1)**i2)      
          quark(i1,i2)=0
          iso(i1,i2)=0
          gen(i1,i2)=0
          do i3=0,1
          do i4=-1,+1,2
          do i5=1,3
            if(fname(i1,i2).eq.gfname(i3,i4,i5))then
              quark(i1,i2)=i3
              iso(i1,i2)=i4
              gen(i1,i2)=i5
            endif
          enddo
          enddo
          enddo
        enddo
        do i2=nparticle+3,maxe
          fname(i1,i2)=' '
          dfname(i1,i2)=' '
        enddo
c qg=1 and 6 quarks in final state not supported
        if(quark(i1,3)+quark(i1,4)+quark(i1,5)+quark(i1,6)+quark(i1,7)
     *    +quark(i1,8).eq.6.and.nparticle.eq.6.and.qg.eq.1)then
          write(*,'(a)')' qg=1 not supported for e+e- -> 6 quarks.'
          stop
        endif     
      enddo
c setting parameter
      call parameter
      pi=4d0*datan(1d0)
      conv=3.8937966d11        ! conversion factor GeV^-2 to fbarns
      factor=conv/(2d0*pi)**(3*nparticle-4)/(2d0*energy**2)
c calculate parameters
      cw=mw/mz
      cw2=cw**2
      sw2=1d0-cw2
      sw=sqrt(sw2)
      mw2=mw**2
      mz2=mz**2
      mh2=mh**2
      mt2=mt**2
      me2=me**2
c input-parameter scheme
      if(qalp.eq.0)then
	alpha=alpha0
      elseif(qalp.eq.1)then
	alpha=alphaz
      elseif(qalp.eq.2)then
	alpha=dsqrt(2d0)*gf/pi*mw2*sw2
      else
        write(*,'(a)')' Wrong input for input-parameter scheme (qalp)!'
        stop
      endif
      el=sqrt(4d0*pi*alpha)
      call initparam
c initial-state radiation
      alphaisr=alpha0
      meisr=me
      scale=energy
c output
      numout=0
      maxout=100    ! maximal number of error messages
c initialize Madgraph
c      call coupsm(0)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     setting cut parameters                                      c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c ADLO/TH cuts
      if(scuts.eq.1)then   
        ecutl=1d0              ! charged-lepton energy cut
        ecutq=3d0              ! quark energy cut
        scutqq=5d0             ! quark-quark invariant mass cut
        ccutll=5d0             ! angular cut between charged leptons 
        ccutqq=0d0             ! angular cut between quarks 
        ccutlq=5d0             ! angular cut between charged lepton and quark
        ccutlb=10d0            ! angular cut between charged lepton and beam 
        ccutqb=0d0             ! angular cut between quark and beam  
c LC/TH cuts nach (http://heplix.ikp.physik.tu-darmstadt.de/lc/cc.html)
      elseif(scuts.eq.2)then
        ecutl=1d0              ! charged-lepton energy cut
        ecutq=3d0              ! quark energy cut
        scutqq=10d0            ! quark-quark invariant mass cut
        ccutll=5d0             ! angular cut between charged leptons
        ccutqq=0d0             ! angular cut between quarks
        ccutlq=5d0             ! angular cut between charged lepton and quark
        ccutlb=10d0            ! angular cut between charged lepton and beam
        ccutqb=5d0             ! angular cut between quark and beam
c standard cuts
      elseif(scuts.eq.3)then
        ecutl=10d0             ! charged-lepton energy cut
        ecutq=10d0             ! quark energy cut
        scutqq=10d0            ! quark-quark invariant mass cut
        ccutll=5d0             ! angular cut between charged leptons
        ccutqq=0d0             ! angular cut between quarks
        ccutlq=5d0             ! angular cut between charged lepton and quark
        ccutlb=5d0             ! angular cut between charged lepton and beam
        ccutqb=5d0             ! angular cut between quark and beam
      endif
c filling cut parameters
      if(scuts.eq.1.or.scuts.eq.2.or.scuts.eq.3.or.scuts.eq.10)then     
        do i1=1,nfs
          do i2=3,nparticle+2
            ecut(i2)=0d0
            ccut(1,i2)=0d0
            if(quark(i1,i2).eq.0.and.iso(i1,i2).lt.0)then ! charged leptons
              ecut(i2)=ecutl
              ccut(1,i2)=ccutlb
            elseif(quark(i1,i2).eq.1)then                 ! quarks
              ecut(i2)=ecutq
              ccut(1,i2)=ccutqb
            endif
            ccut(2,i2)=ccut(1,i2)
            do i3=3,nparticle+2
              scut(i2,i3)=0d0
              ccut(i2,i3)=0d0
              if(quark(i1,i2).eq.1.and.quark(i1,i3).eq.1)then
                scut(i2,i3)=scutqq
                ccut(i2,i3)=ccutqq
              elseif(quark(i1,i2).eq.0.and.iso(i1,i2).lt.0.and.
     *          quark(i1,i3).eq.0.and.iso(i1,i3).lt.0)then
                ccut(i2,i3)=ccutll
              elseif(quark(i1,i2).eq.0.and.iso(i1,i2).lt.0.and.
     *          quark(i1,i3).eq.1)then
                ccut(i2,i3)=ccutlq
              endif          
            enddo
          enddo
c check whether cut differ between processes
          do i2=1,maxe
          do i3=1,maxe
            if(i1.eq.1)then
              echeck(i2)=ecut(i2)
              ccheck(i2,i3)=ccut(i2,i3)
              scheck(i2,i3)=scut(i2,i3)
            endif
            if(echeck(i2).ne.ecut(i2).or.ccheck(i2,i3).ne.
     *        ccut(i2,i3).or.scheck(i2,i3).ne.scut(i2,i3))then
              write(*,'(a)')
     *          ' Cuts not uniquely defined for these processes.'
              write(*,'(a)')' Calculate processes separately!'
              stop
            endif
          enddo
          enddo
        enddo
      endif
c calculating cut parameters
      do i1=1,nparticle+2
      do i2=1,nparticle+2
        ccut(i1,i2)=dcos(ccut(i1,i2)*pi/180d0)
        scut(i1,i2)=scut(i1,i2)**2
      enddo
      enddo
      do i1=1,nparticle+2
      do i2=1,nparticle+2
        scut(i1,i2)=max(scut(i1,i2),scut(i2,i1))
        ccut(i1,i2)=min(ccut(i1,i2),ccut(i2,i1))
      enddo
      enddo
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     output                                                      c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      i2=0
      do i1=1,90
        if(outputfile(i1:i1).eq.' ')i2=1
        if(i2.eq.1)outputfile(i1:i1)=' '
      enddo
      if(outputfile(1:1).eq.' ')then
        nout=6 
      else
        nout=22
        open(unit=nout,file=outputfile,status='unknown')
      endif
c output
      write(nout,'(a)')' '
      write(nout,'(a)')'                      LUSIFER'  
      write(nout,'(a)')'                      ======='  
      write(nout,'(a)')' '
      write(nout,'(a)')' Input parameters:'
      write(nout,'(a)')' '
 1000 format(4x,'energy = ',f10.6,',',/,
     *  2x,'alpha(0) = 1/', f10.6,',',
     *	3x,'alpha(MZ) = 1/',f9.5,',',3x,'alpha_s = ',f7.5,',',/,
     *	8x,'GF = ',g12.7,',',/,8x,'MW = ',f9.5,',',
     *	13x,'MZ = ',f9.5,',',10x,'MH = ',f9.5,',',/,
     *	8x,'GW = ',f9.5,',',13x,'GZ = ',f9.5,',',
     *	10x,'GH = ',f9.5,',',/,8x,'mt = ',f9.5,',',
     *	13x,'me = ',g13.8,','/,8x,'Gt = ',f9.5,'.')
      write(nout,1000)energy,1d0/alpha0,1d0/alphaz,alphas,gf,
     *	mw,mz,mh,gw,gz,gh,mt,me,gt
      write(nout,'(a)')' '
c process name
      do i1=1,nfs
        process=dfname(i1,1)//fname(i1,1)//
     *    dfname(i1,2)//fname(i1,2)//' -> '//
     *    dfname(i1,3)//fname(i1,3)//dfname(i1,4)//fname(i1,4)//
     *    dfname(i1,5)//fname(i1,5)//dfname(i1,6)//fname(i1,6)//
     *    dfname(i1,7)//fname(i1,7)//dfname(i1,8)//fname(i1,8)//' '
        do i2=98,1,-1
          if(process(i2:i2+1).eq.'  ')then
            process=process(1:i2)//process(i2+2:100)//' '
          endif
        enddo
        write(nout,'(" Process ",i2,":",a60)')i1,process
        write(nout,'(13x,"weight = ",g10.5)')wgt(i1)  
      enddo
c output options
      write(nout,'(a)')' '
c input-parameter scheme
      if(qalp.eq.0)then
        write(nout,'(a9,i2,(a))')'qalp=',qalp,
     *    ': alpha(0)-parametrization scheme.'
      elseif(qalp.eq.1)then
        write(nout,'(a9,i2,(a))')'qalp=',qalp,
     *    ': alpha(MZ)-parametrization scheme.'
      elseif(qalp.eq.2)then
        write(nout,'(a9,i2,(a))')'qalp=',qalp,
     *    ': GF-parametrization scheme.'
      else 
        write(*,'(a)')' Wrong input for qalp.'
        stop
      endif
c treatment of W width in propagator
      if(qprop.eq.0)then
        write(nout,'(a9,i2,(a))')'qprop=',qprop,
     *    ': width = 0.'
      elseif(qprop.eq.1)then
        write(nout,'(a9,i2,(a))')'qprop=',qprop,
     *    ': constant width.'
      elseif(qprop.eq.2)then
        write(nout,'(a9,i2,(a))')'qprop=',qprop,
     *    ': constant width * theta(p^2).'
      elseif(qprop.eq.3)then
        write(nout,'(a9,i2,(a))')'qprop=',qprop,
     *    ': running  width.'
      elseif(qprop.eq.4)then
        write(nout,'(a9,i2,(a))')'qprop=',qprop,
     *    ': constant width and complex sw,cw.'
      else 
        write(*,'(a)')' Wrong input for qprop.'
        stop
      endif
c gluonic diagrams
      if(qg.eq.0)then
        write(nout,'(a9,i2,(a))')'qg=',qg,
     *    ': no gluonic diagrams included.'
      elseif(qg.eq.1)then
        write(nout,'(a9,i2,(a))')'qg=',qg,
     *    ': gluonic diagrams included.'
      else 
        write(*,'(a)')' Wrong input for qg.'
        stop
      endif
c initial-state radiation
      if(sisr.eq.0)then
        write(nout,'(a9,i2,(a))')'sisr=',sisr,
     *    ': initial-state radiation not included.'
      elseif(sisr.eq.1)then
        write(nout,'(a9,i2,(a))')'sisr=',sisr,
     *    ': initial-state radiation included.'
      else 
        write(*,'(a)')' Wrong input for sisr.'
        stop
      endif
c separation cuts
      write(nout,'(a)')' '
      if(scuts.eq.0)then
        write(nout,'(a9,i2,(a))')'scuts=',scuts,
     $        ': no separation cuts !'
      else
        write(nout,'(a9,i2,(a))')'scuts=',scuts,
     $        ': with separation cuts:'
        do i1=1,nparticle+2
          if(ecut(i1).gt.0d0)then
            write(nout,'(" energy(",i1,")  > ",f9.5," GeV")')
     *        i1,ecut(i1)
          endif
        enddo
        do i1=1,nparticle+2
        do i2=i1+1,nparticle+2
          if(ccut(i1,i2).lt.1d0)then
            write(nout,'(" angle(",i1,",",i1,") > ",f9.5," deg")')
     *        i1,i2,dacos(ccut(i1,i2))/pi*180d0
          endif
        enddo
        enddo
        do i1=1,nparticle+2
        do i2=i1+1,nparticle+2
          if(scut(i1,i2).gt.0d0)then
            write(nout,'(" mass(",i1,",",i1,")  > ",f9.5," GeV")')
     *        i1,i2,dsqrt(scut(i1,i2))
          endif
        enddo
        enddo
      endif
c beam polarizations
      write(nout,'(a)')' '
      write(nout,'(a)')' Beam polaraization:'      
      write(nout,'(" polarization of e+ = ",f9.5)')pp
      write(nout,'(" polarization of e- = ",f9.5)')pm
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     initializing generator                                      c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c particle masses
      do i1=0,maxv
        mass(i1)=0d0
        width(i1)=0d0
      enddo
      mass(6)=mt
      width(6)=gt
      mass(23)=mz
      width(23)=gz
      mass(24)=mw
      width(24)=gw
      mass(25)=mh
      width(25)=gh
c particle names
      gname(0,-1,1)='el '
      gname(0,-1,2)='mu '
      gname(0,-1,3)='ta ' 
      gname(0,+1,1)='ne ' 
      gname(0,+1,2)='nm '
      gname(0,+1,3)='nt '
      gname(1,-1,1)='dq '
      gname(1,-1,2)='sq '
      gname(1,-1,3)='bq '
      gname(1,+1,1)='uq '
      gname(1,+1,2)='cq '
      gname(1,+1,3)='tq '
      generator=1
      nchannel(generator)=0
      do i1=1,nfs
        do i2=1,nparticle+2
          if(iso(i1,i2).ne.0)then
            name(i2)=gname(quark(i1,i2),iso(i1,i2),gen(i1,i2))
          endif
          if(dir(i2)*(-1)**i2.eq.-1)name(i2)(3:3)='~'
        enddo
        lightfermions=0
        includecuts=1
        sout=0
        if(i1.eq.nfs)sout=1
        call initphasespace(name,generator,lightfermions,includecuts,
     *    sout)
      enddo
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     numerical integration                                       c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      nsteps=1000000            ! output all 'nsteps' times
      if(nevents.ge.nsteps)then
        write(nout,*)' '
        write(nout,'(a)')'    events  :  intermediary results   :'//
     *    '  preliminary results '
      endif
c beam momenta               
      kbeam(1,0)=0.5d0*energy
      kbeam(1,1)=0d0
      kbeam(1,2)=0d0
      kbeam(1,3)=-0.5d0*energy
      kbeam(2,0)=0.5d0*energy
      kbeam(2,1)=0d0
      kbeam(2,2)=0d0
      kbeam(2,3)=0.5d0*energy
      average=0d0
      sigma=0d0
      do i1=1,nfs
        avsub(i1)=0d0
        sisub(i1)=0d0
      enddo
      av=0d0
      si=0d0
      averagemax=0d0
      rejected=0
      call settings(kbeam,k,0d0,0,1)
      do n=1,nevents
        weight=0d0
        weightsub=0d0
        call rans(random(1))        
        do i1=1,nchannel(generator)
          if(random(1).ge.betaopt(i1-1,generator).and.
     *      random(1).le.betaopt(i1,generator))then
            channel=i1         
          endif
        enddo
        switch=1
        if(sisr.eq.1)then
          call rans(random(1))
          call rans(random(2))
          call isr(random,x1,x2,wisr,switch)
        else
          wisr=1d0
          x1=1
          x2=1
        endif
        do i1=1,3*nparticle-4
          call rans(random(i1))
        enddo
        call phasespace(random,kbeam,k,x1,x2,g(1),channel,generator,
     *    switch)
        call cut(kbeam,k,nparticle+2,nocut)
        if(switch.eq.1.and.nocut.eq.1)then
          switch=2
          gsum=0d0
          call density(g,generator,switch)
          do i1=1,nchannel(generator)
            gsum=gsum+g(i1)*alphaopt(i1,opt(generator),generator)
          enddo
          if(switch.eq.2)then
            call setprods(k,dir)
            weight=m2(k)*wisr*factor/gsum
            do i1=1,nfs
              weightsub=m2fs(i1)*wisr*factor/gsum
              avsub(i1)=avsub(i1)+weightsub
              sisub(i1)=sisub(i1)+weightsub**2
            enddo
            average=average+weight
            sigma=sigma+weight**2
            av=av+weight
            si=si+weight**2
            call settings(kbeam,k,weight,n,2)
          endif
        endif
c preliminary results
        if(mod(n,nsteps).eq.0)then
          write(nout,'(i10,2("  : ",f10.5," +-",f9.5))')n,
     *      av/dble(nsteps),
     *      dsqrt(dabs(si-av**2/dble(nsteps)))/dble(nsteps),
     *      average/dble(n),
     *      dsqrt(dabs(sigma-average**2/dble(n)))/dble(n)
          av=0d0
          si=0d0
        endif
c maximal weight
        if(weight.gt.averagemax)then
          averagemax=weight
          channelmax=channel
          nmax=n
        endif
c rejected weight
        if(weight.eq.0d0)then
          rejected=rejected+1
        endif
c optimization
        call optimization(weight,g,gsum,n,generator,
     *    nchannel(generator))
        call settings(kbeam,k,weight,n,3)
      enddo
      average=average/dble(nevents)
      sigma=sigma/dble(nevents)**2
      sigma=dsqrt(dabs(sigma-average**2/dble(nevents)))
      averagemax=averagemax/dble(nevents)
      call settings(kbeam,k,weight,n,4)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     output                                                      c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 1001 format(a22,f16.10," fb")
 1002 format(" Rejected events    = ",i3,"%")
 1003 format(" (event = ",i9,", channel = ",i6,")")
      write(nout,'(a)')' '
      write(nout,'(a)')' Result:'
      write(nout,'(a)')' ------- '
      write(nout,'(" Number of events   = ",i16)')nevents
      write(nout,1001)' Average            = ',average
      write(nout,1001)' Standard deviation = ',sigma
      write(nout,1002)(100*rejected)/nevents
      write(nout,1001)' Maximal weight     = ',averagemax
      write(nout,1003)nmax,channelmax
c subprocesses
      if(nparticle.eq.6.and.nfs.ge.2)then
        write(nout,'(a)')' '
        write(nout,'(a)')' Result for subprocesses:'
        write(nout,'(a)')' ------------------------ '
        do i1=1,nfs
          avsub(i1)=avsub(i1)/dble(nevents)
          sisub(i1)=sisub(i1)/dble(nevents)**2
          sisub(i1)=dsqrt(dabs(sisub(i1)-avsub(i1)**2/dble(nevents)))
          write(nout,'(" Process ",i1,":")')i1
          write(nout,1001)' Average            = ',avsub(i1)
          write(nout,1001)' Standard deviation = ',sisub(i1) 
          write(nout,'(a)')' '
        enddo
      endif
      if(outputfile(1:2).ne.' ')close(nout)	
      end
