ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     setting input parameters                                    c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine parameter
      implicit none
c param
      real*8 pi,el,alpha,alpha0,alphaz,alphas,gf,cw,cw2,sw,sw2
      real*8 mw,mw2,gw,mz,mz2,gz,mh,mh2,gh,me,me2,mt,mt2,gt
      common/lparam/pi,el,alpha,alpha0,alphaz,alphas,gf,cw,cw2,sw,sw2,
     *  mw,mw2,gw,mz,mz2,gz,mh,mh2,gh,me,me2,mt,mt2,gt
      alphas=0.1181d0
      alpha0=1d0/137.0359895d0
      alphaz=1d0/128.887d0
      gf=1.16639D-5
      mw=80.419d0
      gw=2.12d0
      mz=91.1882d0
      gz=2.4952d0
      mh=170d0
      gh=0.3835d0
      mt=174.3d0
      gt=1.6d0
      me=0.51099907d-3   
c check with Madgraph
c      alphas=0d0
c      gw=1d-15
c      gz=1d-15
c      gt=1d-15
c      gh=1d-15
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     applying cut                                                c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine cut(kbeam,k,nexternal,nocut)
      implicit none
c local variables
      integer maxe
      parameter(maxe=8)
      real*8 kbeam(2,0:3),k(maxe,0:3),q(0:3),kvec(maxe),kbeamvec(2)
      real*8 s,prod
      integer i1,i2,i3,nexternal,nocut
c cuts
      real*8 ecut(maxe),scut(maxe,maxe),ccut(maxe,maxe)
      common/cuts/ecut,scut,ccut
      nocut=0
c apply energy cuts
      do i1=3,nexternal
        if(k(i1,0).lt.ecut(i1))return
      enddo
c apply invariant-mass cuts
      do i1=3,nexternal
      do i2=i1+1,nexternal
        do i3=0,3
          q(i3)=k(i1,i3)+k(i2,i3)
        enddo
        s=q(0)*q(0)-q(1)*q(1)-q(2)*q(2)-q(3)*q(3)
        if(s.lt.scut(i1,i2))return
      enddo
      enddo
c apply angular cuts
      do i1=1,2
        kbeamvec(i1)=
     *    dsqrt(kbeam(i1,1)**2+kbeam(i1,2)**2+kbeam(i1,3)**2)
      enddo
      do i1=3,nexternal
        kvec(i1)=dsqrt(k(i1,1)**2+k(i1,2)**2+k(i1,3)**2)
      enddo
      do i1=1,2
      do i2=3,nexternal
        prod=(kbeam(i1,1)*k(i2,1)+kbeam(i1,2)*k(i2,2)
     *        +kbeam(i1,3)*k(i2,3))
        if(prod.gt.ccut(i1,i2)*kbeamvec(i1)*kvec(i2))return
      enddo
      enddo
      do i1=3,nexternal
      do i2=i1+1,nexternal
        prod=(k(i1,1)*k(i2,1)+k(i1,2)*k(i2,2)+k(i1,3)*k(i2,3))
        if(prod.gt.ccut(i1,i2)*kvec(i1)*kvec(i2))return
      enddo
      enddo
c non-standard cuts can be inserted here
      nocut=1
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     subroutine settings                                         c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine settings(kbeam,k,weight,n,steps)
      implicit none
c local variables
      integer maxe,maxh
      parameter(maxe=8,maxh=9)
      real*8 kbeam(2,0:3),k(maxe,0:3),weight,energy,help
      integer n,steps
      character*10 name
c chisto
      integer shisto,nhisto(maxh)
      common/chisto/shisto,nhisto
      if(shisto.eq.0)return
      if(weight.eq.0d0.and.steps.eq.2)return
      energy=kbeam(1,0)+kbeam(2,0)
      if(nhisto(1).eq.1)then
        name='dat.01'
        call histogram(-0.5d0,0.5d0,0d0,weight,1,n,name,1,steps)      
      endif
      if(nhisto(2).eq.1)then
        name='dat.02'
        call histogram(0d0,0.5d0*energy,k(3,0),weight,2,n,name,100,
     *    steps)      
      endif
      if(nhisto(3).eq.1)then
        name='dat.03'
        call histogram(0d0,0.5d0*energy,k(4,0),weight,3,n,name,100,
     *    steps)      
      endif
      if(nhisto(4).eq.1)then
        name='dat.04'
        call histogram(0d0,0.5d0*energy,k(5,0),weight,4,n,name,100,
     *    steps)      
      endif
      if(nhisto(5).eq.1)then
        name='dat.05'
        call histogram(0d0,0.5d0*energy,k(6,0),weight,5,n,name,100,
     *    steps)      
      endif
      if(nhisto(6).eq.1)then
        name='dat.06'
        call histogram(0d0,0.5d0*energy,k(7,0),weight,6,n,name,100,
     *    steps)      
      endif
      if(nhisto(7).eq.1)then
        name='dat.07'
        call histogram(0d0,0.5d0*energy,k(8,0),weight,7,n,name,100,
     *    steps)
      endif
      if(nhisto(8).eq.1)then
        name='dat.08'
        help=dsqrt(dabs(
     *    (k(3,0)+k(4,0)+k(5,0))**2-(k(3,1)+k(4,1)+k(5,1))**2
     *    -(k(3,2)+k(4,2)+k(5,2))**2-(k(3,3)+k(4,3)+k(5,3))**2))
        call histogram(150d0,200d0,help,weight,8,n,name,100,steps)
      endif
      if(nhisto(9).eq.1)then
        name='dat.09'
        help=dsqrt(dabs(
     *    (k(3,0)+k(4,0)+k(6,0))**2-(k(3,1)+k(4,1)+k(6,1))**2
     *    -(k(3,2)+k(4,2)+k(6,2))**2-(k(3,3)+k(4,3)+k(6,3))**2))
        call histogram(150d0,200d0,help,weight,9,n,name,100,steps)
      endif
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     histogram routine                                           c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine histogram(min,max,x,y,histo,n,name,parts,steps)
      implicit none
c local variable
      integer maxh,maxp
      parameter(maxh=9,maxp=100)
      real*8 average(maxh,maxp),sigma(maxh,maxp),ysum(maxh,maxp)
      real*8 avborn(maxh,maxp),siborn(maxh,maxp)
      real*8 min,max,x,y,av,si,avb,sib,shift
      integer i,isum(maxh,maxp),imax(maxh)
      integer i1,i2,histo,parts,n,nout,steps
      character*10 name
      save average,sigma,ysum,isum,imax
c initialization
      if(steps.eq.1)then
        do i1=1,maxh
          imax(i1)=0
          do i2=1,maxp
            ysum(i1,i2)=0d0
            average(i1,i2)=0d0
            sigma(i1,i2)=0d0
            avborn(i1,i2)=0d0
            siborn(i1,i2)=0d0
            isum(i1,i2)=0
          enddo
        enddo
      endif
c input of single subevents
      if(steps.eq.2)then
        if(x.ge.min.and.x.lt.max)then
          i=int((x-min)/(max-min)*parts)+1
          ysum(histo,i)=y+ysum(histo,i)
          imax(histo)=imax(histo)+1
          isum(histo,imax(histo))=i
        endif
c input born event and final calculation of whole event
      elseif(steps.eq.3)then        
        if(x.ge.min.and.x.lt.max)then
          i=int((x-min)/(max-min)*parts)+1
          avborn(histo,i)=y+avborn(histo,i)
          siborn(histo,i)=y*y+siborn(histo,i)
        endif
        if(imax(histo).ge.1)then
          do i1=1,imax(histo)
            i=isum(histo,i1)
            average(histo,i)=ysum(histo,i)+average(histo,i)
            sigma(histo,i)=ysum(histo,i)*ysum(histo,i)+sigma(histo,i)
            ysum(histo,i)=0d0
          enddo
        endif
        imax(histo)=0
c output
      elseif(steps.eq.4)then
        nout=25
        open(unit=nout,file=name,status='unknown')
        shift=1d0
        write(nout,'("# histogram:",i3,", bins:",i4)'),histo,parts
        write(nout,'(a)')'# '
        do i=1,parts
          av=average(histo,i)/dble(n)/(max-min)*dble(parts)
          si=sigma(histo,i)/(dble(n)*(max-min)/dble(parts))**2
          si=dsqrt(dabs(si-av*av/dble(n)))
          avb=avborn(histo,i)/dble(n)/(max-min)*dble(parts)
          sib=siborn(histo,i)/(dble(n)*(max-min)/dble(parts))**2
          sib=dsqrt(dabs(sib-avb*avb/dble(n)))
          write(nout,'(5(e12.6,2x))') 
     *      min+(max-min)/dble(parts)*(dble(i)-shift),av,si,avb,sib
        enddo
        write(nout,'(a)') '# '
        if(shift.eq.0d0)write(nout,'(a)')'# x = right corner'
        if(shift.eq.0.5d0)write(nout,'(a)')'# x = mid'
        if(shift.eq.1d0)write(nout,'(a)')'# x = left corner'
        close(nout)
      endif
      end
